/*
 * ِChrome dino (T-Rex) Game for arduino
 * First Code: https://www.hackster.io/Unsigned_Arduino/the-chrome-dino-game-on-an-lcd-shield-883afb
 * Editted By: DIGI BOY (SINA)
 * web site: https://sisoog.com
 */
 
#include <LiquidCrystal.h>
#include "bitmaps.h"
#include "pitches.h"

#define PIN_MELODY 9
#include "melody.h"
int best_score=0;
int  jump_duration = 0;
const int rs = 8, en = 7, d4 = 6, d5 = 5, d6 = 4, d7 = 3;
LiquidCrystal lcd(rs, en, d4, d5, d6, d7);


#define PIN_BTN 10

byte runnerArea[16] {32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32};
byte jump = 32;

int score = 0;
bool freeze_score = 0;

byte correct_code = 123;

unsigned long previousMillis = 0;
unsigned long previousMillisLED = 0;
unsigned long jumpTime = 0;
const int jumpLength = 500;

#define checkSafe runnerArea[1] == 32 || runnerArea[1] == 0

const byte chance_of_ob = 15;
int speedOfScroller = 300;


int read_LCD_buttons() {

  if (!digitalRead(PIN_BTN))    {Serial.println("S"); return PIN_BTN;}
  return 0;
}



void drawRandChar() {
  lcd.setCursor(random(3, 15), 1);
  lcd.write(byte(random(1, 3)));
}

void drawSplashGraphics() {
  lcd.setCursor(0, 1);
  lcd.write(byte(3));
  lcd.setCursor(15, 1);
  lcd.write(byte(3));
  lcd.setCursor(1, 1);
  lcd.write(byte(0));
  drawRandChar();
  drawRandChar();
  drawRandChar();
}
bool leave = 0;
byte code = 0;
void wrong() {
  lcd.setCursor(0, 1);
  lcd.print("Incorrect!");
  code = 0;
  delay(250);
  lcd.setCursor(0, 1);
  lcd.print("Code: ");
}

void drawBarrier() {
  runnerArea[0] = 3;
  runnerArea[15] = 3;
}

void updateLcd() {
  for (int i = 0; i <= 15; i++) {
    lcd.setCursor(i, 1);
    lcd.write(runnerArea[i]);
  }
  lcd.setCursor(1, 0);
  lcd.write(jump);
}

void printScore() {
  lcd.setCursor(4, 0);
  lcd.print("Score: ");
  lcd.setCursor(11, 0);
  lcd.print(score);
}

void showSplashScreen(int delayTime, boolean wait_for_start) {
  lcd.home();
  lcd.print("Sisoog.com");
  delay((delayTime+1)/2);
  lcd.clear();
  lcd.print("Chrome Dino Game");
  play_music();
  drawSplashGraphics();
  delay(delayTime);
  if (wait_for_start) {
    while (read_LCD_buttons() != PIN_BTN) {
      //checkForEEPROMUserInitErase();
    }
  }
  lcd.clear();
}

void setup() {
  
  lcd.begin(16, 2);
  Serial.begin(9600);
pinMode(PIN_BTN, INPUT_PULLUP);

  lcd.createChar(0, dino);
  lcd.createChar(1, cacti);
  lcd.createChar(2, bird);
  lcd.createChar(3, block);
   

  randomSeed(A1);
  lcd.clear();
  showSplashScreen(1000, true);
}



void loop() 
{
  unsigned long currentMillis = millis();
  unsigned long currentMillisOb = millis();
  if (currentMillisOb - previousMillis >= speedOfScroller) {
    previousMillis = currentMillisOb;
    if (random(chance_of_ob) == 0) {
      runnerArea[15] = 1;
    } else if (random(chance_of_ob) == 1) {
      runnerArea[15] = 2;
    } else {
      runnerArea[15] = 32;
    }
    for (int i = 0; i <= 15; i++) {
      runnerArea[i] = runnerArea[i + 1];
    }
    if (freeze_score == 0) {
      score++;
    }
  }
  drawBarrier();

if (read_LCD_buttons() == PIN_BTN) jump_duration++; else jump_duration = 0;

  if (read_LCD_buttons() == PIN_BTN && jump_duration<100) {
    jump_duration ++;
    // runnerArea[1] = 32;
    if (runnerArea[1] != 32 && (runnerArea[1] != 1 || runnerArea[1] != 2)) {
      runnerArea[1] = 32;
      tone(PIN_MELODY, NOTE_DS2, 100);
    }
    jump = 0;
    freeze_score = 1;
    jumpTime = millis();
  }

  Serial.print(jump_duration);
    printScore();
  if (millis() - jumpTime >= jumpLength) {
    if (checkSafe) {
      runnerArea[1] = 0;
      jump = 32;
      freeze_score = 0;
    } else {
      showCrashScreen();
    }
  }
  updateLcd();


  if (millis() - previousMillisLED >= 500) 
  {
    previousMillisLED = currentMillis;
    digitalWrite(13, !digitalRead(13));
  }
}



void showCrashScreen() {
  lcd.setCursor(4, 1);
  lcd.print("Game Over!");
  play_game_over();
  lcd.setCursor(4, 1);
  lcd.print("Best: ");
  lcd.setCursor(10, 1);
  lcd.print("      ");
  lcd.setCursor(10, 1);
 if (best_score <= score) {
    best_score = score;
  }
 lcd.print(best_score);

 while (read_LCD_buttons() != PIN_BTN);
  lcd.clear();
 score =0; //For next player
}
